import 'dart:io';

import 'package:datadome_flutter_dio/datadome_logger.dart';
import 'package:flutter/material.dart';
import 'package:webview_cookie_manager/webview_cookie_manager.dart';
import 'package:webview_flutter/webview_flutter.dart';

import 'datadome_secrets.dart';
import 'globals.dart';

class WebviewPage extends StatelessWidget {
  final cookieManager = WebviewCookieManager();
  final your_origin = "your_origin"; // please put your own origin

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('DataDome example app'),
          actions: [
            IconButton(
              icon: Icon(Icons.ac_unit),
              onPressed: () async {
                // Clear cookieManager cookies
                await cookieManager.clearCookies();
              },
            )
          ],
        ),
        body: WebView(
          initialUrl: test_url,
          javascriptMode: JavascriptMode.unrestricted,
          onWebViewCreated: (controller) async {
            // Get stored DataDome cookie
            String cookieValue = await dataDomeInterceptor.getDataDomeCookie();

            var wvCookie = Cookie.fromSetCookieValue(cookieValue);
            // Add DataDome cookie to cookie manager
            await cookieManager.setCookies([wvCookie], origin: your_origin);
          },
          onPageFinished: (String url) async {
            final cookies = await cookieManager.getCookies(url);
            for (var item in cookies) {
              if(item.name == "datadome") {
                // Update DataDome cookie store with the new cookie value.
                dataDomeInterceptor.setDataDomeCookie(item.toString());
              }
            }
          },
        ),
      ),
    );
  }
}

