import 'package:datadome_flutter_dio/tracking/event_data.dart';
import 'package:datadome_flutter_dio/tracking/event_tracker.dart';
import 'package:flutter/material.dart';
import 'package:webview_flutter/webview_flutter.dart';

class CaptchaPage extends StatelessWidget {
  final String? captchaUrl;
  final ValueChanged<String>? onCaptchaResolved;
  static bool isDisplayed = false;

  const CaptchaPage({Key? key, this.captchaUrl, this.onCaptchaResolved}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return new WillPopScope(
      onWillPop: () async => false,
      child: new Scaffold(
          body: Builder(builder: (BuildContext context) {
            return WebView(
                initialUrl: captchaUrl,
                javascriptMode: JavascriptMode.unrestricted,
                javascriptChannels: javascriptListeners(context)
            );
          })
      ),
    );
  }

  Set<JavascriptChannel> javascriptListeners(BuildContext context) {
    return ['ReactNativeWebView', 'onCaptchaSuccess', 'android'].map((name) =>
      JavascriptChannel(
          name: name,
          onMessageReceived: (JavascriptMessage message) {
            this.onCaptchaResolved!(message.message);
            EventTracker().addEvent(getEvent(Events.CAPTCHA_SUCCESS, EventTracker.sourceSdk));
          })
    ).toSet();
  }
}