class EventData {
  final int id;
  final String message;
  final String source;
  final int date = DateTime.now().millisecondsSinceEpoch;

  EventData(this.id, this.message, this.source);

  String customJsonString() {
    return "{\"id\":$id, \"message\":\"$message\", \"source\":\"$source\", \"date\":$date}";
  }
}

enum Events {
  NULL_CONTEXT,
  RESPONSE_VALIDATION,
  CAPTCHA_SUCCESS,
  CAPTCHA_FAILURE,
  TOUCH_DOWN,
  TOUCH_UP,
  TOUCH_MOVE,
  UNKNOWN_TOUCH_EVENT,
}

EventData getEvent(Events event, String source)  {
  return new EventData(event.index, event.nameValue, source);
}

extension eventValue on Events {
  String get nameValue {
    switch(this) {
      case Events.NULL_CONTEXT:
        return "empty applicationRef";
        break;
      case Events.RESPONSE_VALIDATION:
        return "response validation";
        break;
      case Events.CAPTCHA_SUCCESS:
        return "captcha success";
        break;
      case Events.CAPTCHA_FAILURE:
        return "captcha failure";
        break;
      case Events.TOUCH_DOWN:
        return "touch down";
        break;
      case Events.TOUCH_UP:
        return "touch up";
        break;
      case Events.TOUCH_MOVE:
        return "touch move";
        break;
      case Events.UNKNOWN_TOUCH_EVENT:
        return "Unknown touch event";
        break;
    }
  }
}